package com.gic.haoban.manage.service.service.contact;

import com.gic.api.base.commons.BusinessException;
import com.gic.haoban.manage.api.qdto.contact.ContactLogQDTO;
import com.gic.haoban.manage.service.entity.contact.TabContactLog;

import java.util.Date;

public interface ContactLogService {


    /**
     * 保存建联记录
     *
     * @param qdto
     */
    void saveContactLog(ContactLogQDTO qdto) throws BusinessException;

    /**
     * 清除建联状态
     *
     * @param memberId
     * @param clearType 1 消费清除 2 换绑主导购
     */
    void clearContactLog(String memberId, Integer clearType);

    /**
     * 获取最近一条有效建联记录
     *
     * @param memberId
     * @return
     */
    TabContactLog getClerkContactTime(String memberId);

    /**
     * 根据时间获取最近一条建联记录
     * @param memberId
     * @param beginTime
     * @return
     */
    TabContactLog getLastByTime(String memberId, Date beginTime,Date endTime);
}
