package com.gic.haoban.manage.web.vo.content;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Author MUSI
 * @Date 2023/3/29 12:53 PM
 * @Description
 * @Version
 **/
@Data
public class InteractRecordExtendInfoVO implements Serializable {

    private static final long serialVersionUID = 799914036029100258L;

    /**
     * 商品信息
     */
    private List<ExtendGoodsInfo> extendGoodsInfos;

    /**
     * 订单信息
     */
    private List<ExtendOrderInfo> extendOrderInfos;

    /**
     * 失效商品数量
     */
    private Integer invalidGoodsNum;

    /**
     * 按组分享素材扩展商品信息
     */
    private List<List<ExtendGoodsInfo>> groupExtendGoodsInfos;

    /**
     * 按组分享失效商品数量
     */
    private Integer groupInvalidGoodsNum;

    @Data
    public static class ExtendGoodsInfo {

        /**
         * 商品id
         */
        private String goodsId;
        /**
         * 商品名称
         */
        private String goodsName;

        /**
         * 商品主图
         */
        private String goodsImageUrl;

        /**
         * 商品货号
         */
        private String goodsCode;

        /**
         * 商品规格 红色,S; 白色,S
         */
        private String goodsNorm;
        /**
         * 订单项数量
         */
        private Integer orderNum;

        /**
         * 商品单价
         */
        private BigDecimal salePrice;

        /***
         * 1 erp同步
         * 2 自建
         * @see com.gic.store.goods.enums.GoodsSourceTypeEnum
         */
        private Integer sourceType;
    }

    @Data
    public static class ExtendOrderInfo {
        /**
         * 订单编号
         */
        private String orderNumber;

        /**
         * 订单创建时间
         */
        private Date orderCreateTime;

        /**
         * 订单商品项总数
         */
        private Integer orderTotalNum;

        /**
         * 订单应付
         */
        private BigDecimal orderPay;

        /**
         * 订单实付
         */
        private BigDecimal realPay;

        /**
         * 订单项商品信息
         */
        private List<ExtendGoodsInfo> orderGoodsInfos;
    }
}
