package com.gic.haoban.manage.web.vo.content.potential;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.gic.haoban.manage.api.enums.content.InteractRecordExtendInfoDTO;
import com.gic.haoban.manage.web.vo.content.ContentMaterialInfoVO;
import com.gic.haoban.manage.web.vo.content.SimpleGoodsInfoVO;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * @Author MUSI
 * @Date 2023/3/28 9:53 AM
 * @Description
 * @Version
 **/
@Data
public class PotentialCustomerVO implements Serializable {

    /**
     * 销售线索id
     */
    @JsonSerialize(using = ToStringSerializer.class)
    private Long potentialCustomerId;

    /**
     * 会员名称
     */
    private String memberName;

    /**
     * 会员昵称
     */
    private String memberNickName;

    /**
     * 会员头像
     */
    private String memberImageUrl;

    /**
     * 会员id
     */
    private String memberId;

    /**
     * 最后访问时间
     */
    private Date lastAccessTime;

    /**
     * 会员手机号
     */
    private String memberPhone;

    /**
     * 是否导购星标客户
     * 1 是; 0否
     */
    private Integer starFlag;

    /**
     * 导购是否查看
     * 1 已查看 0 未查看;
     */
    private Integer seeFlag;

    /**
     * 销售线索描述
     * 通过XXX访问XXX
     */
    private String desc;

    /**
     * 最近30天访问次数
     */
    private Integer visitNum;

    /**
     * 导购与会员是否有好友
     * 1 是好友; 0不是
     */
    private Integer hasMemberRelation;

    /**
     * 会员全渠道成交
     * 1 有过成交; 0 没有成交
     */
    private Integer dealRecord;

    /**
     * 素材信息 bizType == 1 读取
     */
    private ContentMaterialInfoVO contentMaterialInfoVO;

    /**
     * 商品信息 bizType == 2 时
     */
    private SimpleGoodsInfoVO simpleGoodsInfoVO;

    /**
     * 第几次访问
     */
    private Integer times;

    /**
     * 停留时长 单位秒
     */
    private Integer durationTime;

    /**
     * 业务类型
     * @see com.gic.haoban.manage.api.enums.content.ShareBizType
     */
    private Integer bizType;

    /**
     * 业务id
     */
    private String bizId;

    /**
     * 扩展信息
     */
    private InteractRecordExtendInfoVo extendInfo;
}
